# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para seriesmu
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------
import urlparse,urllib2,urllib,re
import os,sys

from core import logger
from core import config
from core import scrapertools
from core.item import Item
from servers import servertools

__channel__ = "seriesmu1"
__category__ = "F,S,D"
__type__ = "generic"
__title__ = "SeriesMU1"
__language__ = "ES"

DEBUG = config.get_setting("debug")

host = "http://series.mu/"
'''
_HEADERS_ = [
    ['Accept','text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8'],
    ['Accept-Encoding','gzip, deflate'],
    ['Accept-Language','es-ES,es;q=0.8,en-US;q=0.5,en;q=0.3'],
    ['Connection','keep-alive'],
    ['Cookie','__cfduid=dfdbb8a28d4e81264d4d822c9e4a0e6101422189808; lang=es_ES; token=2d149a83dde24907113bd27a2d14777b; uuid=6fb38c08b7; _gat=1'],
    ['Host','series.mu'],
    ['User-Agent','Mozilla/5.0 (Windows NT 6.1; WOW64; rv:34.0) Gecko/20100101 Firefox/34.0']
]
'''

_HEADERS_ = [
    ['User-Agent','Mozilla/5.0 (Windows NT 6.1; WOW64; rv:34.0) Gecko/20100101 Firefox/34.0'],
    ['Acept','text/html, */*; q=0.01'],
    ['Accept-Language','es-ES,es;q=0.8,en-US;q=0.5,en;q=0.3'],
    ['Accept-Encoding','gzip, deflate'],
    ['Content-Type','application/x-www-form-urlencoded; charset=UTF-8'],
    ['X-Requested-With','XMLHttpRequest'],
    ['Referer','http://series.mu/login/'],
    ['Content-Length','25'],
    ['Cookie','__cfduid=dfdbb8a28d4e81264d4d822c9e4a0e6101422189808; lang=es_ES; _ga=GA1.2.476693311.1422189801; _gat=1'],
    ['Connection','keep-alive'],
    ['Pragma','Pragma: no-cache'],
    ['Cahe-Control','no-cache']
]

def isGeneric():
    return True

def login():
    post = "user="+config.get_setting("seriesmuuser")+"&pass="+config.get_setting("seriesmupassword")
    data = scrapertools.cache_page(urlparse.urljoin(host, "/login/"),post=post, headers=_HEADERS_)

    print "QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ"
    print data
    print "QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ"

def mainlist(item):
    logger.info("pelisalacarta.seriesmu mainlist")
    itemlist = []

    if config.get_setting("seriesmuaccount")!="true":
        itemlist.append( Item( channel=__channel__ , title="Habilita tu cuenta en la configuración..." , action="openconfig" , url="" , folder=False ) )
    else:
        login()

        title = "[COLOR orange]Series[/COLOR]"
        itemlist.append( Item(channel=__channel__, title=title, action="catalogo", url=urlparse.urljoin(host, "/catalogo/series/1/"), fanart="http://s24.postimg.org/z6ulldcph/pdkesfan.jpg", thumbnail="http://s16.postimg.org/st4x601d1/pdkesth.jpg", extra='series'))

        title = "[COLOR orange]Peliculas[/COLOR]"
        itemlist.append( Item(channel=__channel__, title=title, action="catalogo", url=urlparse.urljoin(host, "/catalogo/pelis/1/"), fanart="http://s18.postimg.org/wzqonq3w9/pdkhdfan.jpg", thumbnail="http://s8.postimg.org/nn5669ln9/pdkhdthu.jpg", extra='pelis'))

        title = "[COLOR orange]Buscar...[/COLOR]"
        itemlist.append( Item(channel=__channel__, title=title, action="search", url="", fanart="http://s14.postimg.org/ceqajaw2p/pdkbusfan.jpg", thumbnail="http://s13.postimg.org/o85gsftyv/pdkbusthub.jpg"))

    return itemlist

def search(item,texto):
    logger.info("pelisalacarta.seriesmu search")

    item.extra = ""
    if item.url=="":
        item.url = urlparse.urljoin(host, "/search/")
        item.extra = urllib.urlencode({'post':'yes','q':texto})

    try:
       return catalogo(item)
    # Se captura la excepción, para no interrumpir al buscador global si un canal falla
    except:
        import sys
        for line in sys.exc_info():
            logger.error( "%s" % line )
        return []

def catalogo(item):
    logger.info("pelisalacarta.seriesmu catalogo")
    itemlist = []

    # Descarga la página
    if item.extra == "series" or item.extra == "pelis":
        data = scrapertools.cache_page(item.url)
    else:
        data = scrapertools.cache_page(item.url,post=item.extra)
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;","",data)

    #<divclass="col-md-2 media" ><a href="/serie/north-and-south" class="self listmedia"><img class="media-poster" src="http://series.mu/img/media/portada/81645_250.jpg"><h2>Norte y Sur</h2><h3>1985 - 3 temporadas</h3></a></div>

    patron = '<divclass="col-md-2 media" >'
    patron+= '<a href="([^"]+)"[^>]+>'                  # scrapedurl
    patron+= '<img class="media-poster" src="([^"]+)">' # scrapedthumbnail
    patron+= '<h2>([^<]+)</h2>'                         # scrapedtitle
    patron+= '<h3>([^<]+)</h3>'                         # titleplus

    matches = re.compile(patron,re.DOTALL).findall(data)

    for scrapedurl, scrapedthumbnail, scrapedtitle, titleplus in matches:

        accion = scrapertools.find_single_match(scrapedurl, "/(se[^/]+)/")
        accion+= scrapertools.find_single_match(scrapedurl, "/(pe[^/]+)/")

        scrapedurl = urlparse.urljoin(host, scrapedurl)
        titleplus = scrapedtitle+" [COLOR blue]"+titleplus+"[/COLOR]"

        action = "findvideos"
        if accion == "serie":
            action = "episodios"

        itemlist.append( Item(channel=__channel__, title =titleplus , url=scrapedurl, action=action, thumbnail=scrapedthumbnail, show=scrapedtitle, extra=item.extra, folder=True) )

    ## Paginación
    try:
        next_page = scrapertools.get_match(data,'<li><a href="([^"]+)">Siguiente[^<]+</a></li>')
        next_page = urlparse.urljoin(host, next_page)
        itemlist.append( Item(channel=__channel__, title=">> Página siguiente", url=next_page, action="catalogo", extra=item.extra, show=item.show, folder=True) )
    except: pass

    return itemlist

def episodios(item):
    logger.info("pelisalacarta.seriesmu episodios")
    itemlist = []
   
    # Descarga la página
    data = scrapertools.cache_page(item.url)
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;","",data)
   
    patrontemporada = '<ul (temp[^<]+)>(.*?)>Marcar como vista</a>'
    matchestemporadas = re.compile(patrontemporada,re.DOTALL).findall(data)
   
    for nombre_temporada,bloque_episodios in matchestemporadas:
        if (DEBUG): logger.info("nombre_temporada="+nombre_temporada)
        if (DEBUG): logger.info("bloque_episodios="+bloque_episodios)
        # Extrae los episodios

        patron = '<span>(.*?)'
        patron += '</span>([^<]+).*?'
        patron += '<i class="icon-play".*?'
        patron += 'href="([^"]+)"'

        matches = re.compile(patron,re.DOTALL).findall(bloque_episodios)
        scrapertools.printMatches(matches)

        for scrapednumber, scrapedtitle, scrapedurl in matches:
            scrapedtitle = nombre_temporada + "X" + scrapednumber + scrapedtitle
            scrapedtitle = scrapedtitle.replace("="," ")
            scrapedtitle = scrapedtitle.replace("temp","Temporada")
            scrapedurl = urlparse.urljoin(host, scrapedurl)

            itemlist.append( Item(channel=__channel__, title =scrapedtitle , url=scrapedurl, action="findvideos", thumbnail=item.thumbnail, folder=True) )

    if (config.get_platform().startswith("xbmc") or config.get_platform().startswith("boxee")) and len(itemlist)>0:
        itemlist.append( Item(channel=__channel__, title="Añadir esta serie a la biblioteca de XBMC", url=item.url, action="add_serie_to_library", extra="episodios", show=item.show) )

    return itemlist

def findvideos(item):
    logger.info("pelisalacarta.seriesmu findvideos")

    itemlist = []
    # Descarga la pagina
    data = scrapertools.cache_page(item.url)
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;","",data)

    patronlinks = '<div class="sections episode-links online shown">(.*?)<div class="sections episode-comments">'
    matcheslinks = re.compile(patronlinks,re.DOTALL).findall(data)

    for bloque_links in matcheslinks:
        if (DEBUG): logger.info("bloque_links="+bloque_links)
        # Extrae los episodios

        patron = '<li><div class="link-row">'
        patron += '<a href="([^"]+)".*?'
        patron += '<div class="host.*?([^<]+)"></div>.*?'
        patron += '<div class="lang audio">([^<]+)</div>.*?'
        patron += '<div class="quality">([^<]+)</div></a></div></li>'

        matches = re.compile(patron,re.DOTALL).findall(data)
        scrapertools.printMatches(matches)

        for scrapedurl, scrapedhost, scrapedaudio, scrapedcalidad in matches:
            scrapedhost= scrapedhost.replace("net","")
            scrapedhost= scrapedhost.replace("eu","")
            scrapedhost= scrapedhost.replace("sx","")

            scrapedurl = urlparse.urljoin(host, scrapedurl)
            title = scrapedhost + "--" + scrapedaudio + "--" + scrapedcalidad

            itemlist.append( Item(channel=__channel__, action="play", title= title  , url=scrapedurl , thumbnail=item.thumbnail , folder=True) )

    # STRM para todos los enlaces de servidores disponibles
    # Si no existe el archivo STRM de la peícula muestra el item ">> Añadir a la biblioteca..."
    if item.extra == "pelis" and len(itemlist)>0:
        try: itemlist.extend( file_cine_library(item) )
        except: pass

    return itemlist

def file_cine_library(item):
    import os
    from platformcode.xbmc import library
    librarypath = os.path.join(config.get_library_path(),"CINE")
    archivo = library.title_to_folder_name(item.title.strip())
    strmfile = archivo+".strm"
    strmfilepath = os.path.join(librarypath,strmfile)

    if not os.path.exists(strmfilepath):
        itemlist = []
        itemlist.append( Item(channel=item.channel, title=">> Añadir a la biblioteca...", url=item.url, action="add_file_cine_library", extra="episodios", show=archivo) )

    return itemlist

def add_file_cine_library(item):
    from platformcode.xbmc import library, xbmctools
    library.savelibrary( titulo=item.show , url=item.url , thumbnail=item.thumbnail , server=item.server , plot=item.plot , canal=item.channel , category="Cine" , Serie="" , verbose=False, accion="play_from_library", pedirnombre=False, subtitle=item.subtitle )

    itemlist = []
    itemlist.append(Item(title='El vídeo '+item.show+' se ha añadido a la biblioteca'))
    xbmctools.renderItems(itemlist, "", "", "")

    return

def play(item):
    logger.info("pelisalacarta.seriesmu play")

    media_url = scrapertools.get_header_from_response(item.url,header_to_get="location")

    print "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"
    print media_url
    print "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"

    itemlist = servertools.find_video_items(data=media_url)

    return itemlist

